dofile_once("data/scripts/lib/utilities.lua")

--This Mutes any other biome music hapening:
GameTriggerMusicFadeOutAndDequeueAll()

--Get current biome 
local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local current_biome = BiomeMapGetName( x, y )

--We're getting the Time the music starts and then checking the time now, to see if the music time passed
--event_time is the length of the song of my custom song that I added with fmod
local current_time = GameGetRealWorldTimeSinceStarted()
local last_time = tonumber(GlobalsGetValue("custom_biome_music_mod_last_time_played", "0"))
local event_time = tonumber(GlobalsGetValue("custom_biome_music_mod_event_time", "0"))


--Here im very crudely checking if the music played in the last biome is the same as the music played in the current biome, so if that's the case, 
--I don't restart the music, but keep playing it seamlessly between biomes
local outtake = false
local grotto5 = false
local grotto2 = false
local grotto = false
local fungi = false

local previous_bunch = GlobalsGetValue("custom_biome_music_mod_last_bunch", "0")

if current_biome == "$biome_coalmine" or current_biome == "$biome_coalmine_alt" then
	outtake = true
	GlobalsSetValue("custom_biome_music_mod_last_bunch", "coalmine")
elseif current_biome == "$biome_winter" or current_biome == "$biome_winter_caves" then
	grotto5 = true
	GlobalsSetValue("custom_biome_music_mod_last_bunch", "winter")
elseif current_biome == "$biome_rainforest" or current_biome == "$biome_rainforest_dark" then
	grotto = true
	GlobalsSetValue("custom_biome_music_mod_last_bunch", "rainforest")
elseif current_biome == "$biome_vault" or current_biome == "$biome_vault_frozen" or current_biome == "$biome_robobase" then
	grotto2 = true
	GlobalsSetValue("custom_biome_music_mod_last_bunch", "vault")
elseif current_biome == "$biome_fungicave" or current_biome == "$biome_fun" then
	fungi = true
	GlobalsSetValue("custom_biome_music_mod_last_bunch", "fungi")
end

local current_bunch = GlobalsGetValue("custom_biome_music_mod_last_bunch", "0")

if current_time > last_time + event_time or ( GlobalsGetValue("custom_biome_music_mod_previous_biome", "0") ~= current_biome and ( (not outtake and not grotto5 and not grotto2 and not grotto and not fungi) or previous_bunch ~= current_bunch ) ) then
	--attemt to mute any playing music
	GamePlaySound("mods/custom_biome_music_mod/files/sound/my_mod_audio2.bank", "snd_mod2/music_muter", 0, 0)

	EntityAddComponent(entity_id, "LuaComponent", {
		script_source_file="mods/custom_biome_music_mod/files/biome_checker_and_music_player.lua",
		execute_every_n_frame=360
	})
	
	local this_lua_component = GetUpdatedComponentID()
	EntityRemoveComponent(entity_id, this_lua_component)
	
	--If event_time passed (the song is finished) we enable the biome checker again and remove this lua script
end